# Spectators
gamemode spectator @a[team=Spec,gamemode=!spectator]

# Falling in void
execute as @a[team=blue,scores={yPos=..10}] run tp @s 8.5 30.5 34 180 0
execute as @a[team=red,scores={yPos=..10}] run tp @s 8.5 30.5 -21 0 0

# Players going out of bounds
tag @a remove ok
execute at @e[tag=bluey] positioned ~-15 ~-1 ~-21 as @a[dx=30,dy=15,dz=30] run tag @s add ok
execute at @e[tag=redy] positioned ~-15 ~-1 ~-10 as @a[dx=30,dy=15,dz=30] run tag @s add ok
execute as @a[team=blue,tag=!ok] run function bannerbattle:phase2/out_of_bounds_blue
execute as @a[team=red,tag=!ok] run function bannerbattle:phase2/out_of_bounds_red
particle minecraft:ash 7 28 16.0 4.5 2 0 0 15 normal @a[team=blue]
particle minecraft:ash 7 28 1.0 4.5 2 0 0 15 normal @a[team=red]

# Items
tag @e[type=item,nbt={Item:{id:"minecraft:stone_sword"},Age:1s},tag=!ohnoes.sword] add ohnoes.sword
execute at @e[type=item,tag=ohnoes.sword] run give @p minecraft:stone_sword{CanDestroy:["#bannerbattle:valid_blocks"],HideFlags:63,Normalt:1b,Unbreakable:1,Enchantments:[{id:"sharpness",lvl:1}]} 1
execute as @e[type=item,tag=ohnoes.sword] run kill @s

tag @e[type=item,nbt={Item:{id:"minecraft:crossbow"},Age:1s},tag=!ohnoes.crossbow] add ohnoes.crossbow
execute at @e[type=item,tag=ohnoes.crossbow] run give @p minecraft:crossbow{CanDestroy:["#bannerbattle:valid_blocks"],HideFlags:63,Enchantments:[{id:"quick_charge",lvl:2}],Unbreakable:1,Normalt:1b} 1
execute as @e[type=item,tag=ohnoes.crossbow] run kill @s

tag @e[type=item,nbt={Item:{id:"minecraft:wooden_pickaxe"},Age:1s},tag=!ohnoes.pickaxe] add ohnoes.pickaxe
execute at @e[type=item,tag=ohnoes.pickaxe] run give @p minecraft:wooden_pickaxe{CanDestroy:["#bannerbattle:valid_blocks"],Unbreakable:1,display:{Name:'{"text":"Pick of Blockiness"}'},Enchantments:[{id:"efficiency",lvl:1}],HideFlags:63,Normalt:1b} 1
execute as @e[type=item,tag=ohnoes.pickaxe] run kill @s

tag @e[type=item,nbt={Item:{id:"minecraft:wooden_axe"},Age:1s},tag=!ohnoes.axe] add ohnoes.axe
execute at @e[type=item,tag=ohnoes.axe] run give @p minecraft:wooden_axe{CanDestroy:["#bannerbattle:valid_blocks"],Unbreakable:1,display:{Name:'{"text":"A Rather Blunt Axe"}'},Enchantments:[{}],HideFlags:63,Normalt:1b} 1
execute as @e[type=item,tag=ohnoes.axe] run kill @s

tag @e[type=item,nbt={Item:{id:"minecraft:wooden_shovel"},Age:1s},tag=!ohnoes.shovel] add ohnoes.shovel
execute at @e[type=item,tag=ohnoes.shovel] run give @p minecraft:wooden_shovel{CanDestroy:["#bannerbattle:valid_blocks"],Unbreakable:1,display:{Name:'{"text":"Dirt Killer"}'},Enchantments:[{}],HideFlags:63,Normalt:1b} 1
execute as @e[type=item,tag=ohnoes.shovel] run kill @s

# Fallen items
execute as @e[type=item,nbt={Item:{id:"minecraft:shroomlight"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:soul_sand"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:dirt"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:end_stone"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:yellow_wool"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:red_wool"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:blue_wool"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:nether_bricks"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:oak_planks"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:oak_fence"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:cobblestone"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:birch_planks"}},tag=!fallen] run function bannerbattle:process_fallen_item

# Place blocks
execute as @a[scores={place0=1..}] run function bannerbattle:place_block
execute as @a[scores={place1=1..}] run function bannerbattle:place_block
execute as @a[scores={place2=1..}] run function bannerbattle:place_block
execute as @a[scores={place3=1..}] run function bannerbattle:place_block
execute as @a[scores={place4=1..}] run function bannerbattle:place_block
execute as @a[scores={place5=1..}] run function bannerbattle:place_block
execute as @a[scores={place6=1..}] run function bannerbattle:place_block
execute as @a[scores={place7=1..}] run function bannerbattle:place_block
execute as @a[scores={place8=1..}] run function bannerbattle:place_block
execute as @a[scores={place9=1..}] run function bannerbattle:place_block
execute as @a[scores={place10=1..}] run function bannerbattle:place_block

# Time
execute if score timer vars matches 0.. run scoreboard players remove timer vars 1
scoreboard players operation timeSeconds vars = timer vars
scoreboard players operation timeSeconds vars /= 20 const
scoreboard players add timeSeconds vars 1
scoreboard players operation Time: timeDisplay = timeSeconds vars
execute if score timer vars matches 1200 run function bannerbattle:timer_title
execute if score timer vars matches 600 run function bannerbattle:timer_title
execute if score timer vars matches 200 run function bannerbattle:timer_title
execute if score timer vars matches 0 run function bannerbattle:phase2/end1

# Entire team leaves
execute unless entity @a[team=red] unless entity @a[scores={endGame=0}] run function bannerbattle:entire_team_left
execute unless entity @a[team=blue] unless entity @a[scores={endGame=0}] run function bannerbattle:entire_team_left
execute as @a[scores={endGame=1..}] run function bannerbattle:end_game
execute if entity @a[team=red] if entity @a[team=blue] if entity @a[scores={endGame=0}] run scoreboard players reset @a endGame